# Functional Pypelines

![](https://img.shields.io/badge/version-1.0.0-blue.svg)
[![lifecycle](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://www.tidyverse.org/lifecycle/#stable)
[![pre-commit](https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit&logoColor=white)](https://github.com/pre-commit/pre-commit)
[![Coverage](https://raw.githubusercontent.com/8451/functional-pypelines/meta/coverage/coverage.svg)](https://github.com/8451/functional-pypelines/tree/meta/coverage)
[![docs](https://img.shields.io/badge/docs-latest-brightgreen.svg?style=flat)](https://8451.github.io/functional-pypelines)

Functional Pypelines is a framework for making functions more composable. It accomplishes this by exposing a wrapper class,
Pipeline, that allows functions to be chained together using the `>>` operator. In addition to this, an API is exposed
for running a sequence of Pipeline functions using a JSON config.

## Installation
See our installation guide [here](docs/source/installation.md).

## Usage
See our usage guide [here](docs/source/usage.md).

## Contributing
If you would like to contribute to **functional-pypelines**, please read the
[Contributing Guide](docs/source/contributing.md).

## Changelog
A summary of recent updates to **functional-pypelines** can be found in the
[Changelog](docs/source/changelog.md).

## Maintainers

| Maintainer                                                | Email                    |
|-----------------------------------------------------------|--------------------------|
| [Austin Warner](https://github.com/austinwarner-8451)     | austin.warner@8451.com   |
| [Michael Stoepel](https://github.com/michaelstoepel-8451) | michael.stoepel@8451.com |

## Links
- Report a bug or request a feature: https://github.com/8451/functional-pypelines/issues/new/choose
- Documentation: https://8451.github.io/functional-pypelines
